<template>
  <v-layout 
    row 
    wrap>
    <v-flex 
      xs12
      mb-2>
      <v-btn 
        to="receive/new" 
        nuxt>
        Novo Pedido
      </v-btn>
    </v-flex>
    <v-expansion-panel
      expand>
      <v-expansion-panel-content
        v-for="(s, i) in sources"
        :key="i"
      >
        <div slot="header">
          <span class="title">
            Saída: {{ getLocation(s).name }} ({{ orders.filter(o => o.from === s).length }})
          </span>
        </div>
        <v-card light>
          <v-card-text>
            <v-layout>
              <v-flex 
                v-for="(o, i) in orders.filter(o => o.from === s)" 
                :key="i"
                xs4
                light
                pa-2>
                <v-card 
                  :to="'receive/' + o._id"
                  dark
                >
                  <v-toolbar dense>
                    <span class="title">{{ o.customer.name }}</span>
                  </v-toolbar>
                  <v-card-text>
                    <span class="heading">{{ o.packages.length }} pacotes</span>
                  </v-card-text>
                  <v-card-text>
                    <v-chip 
                      v-for="(cnt, d) in getPackagesCount(o.packages)"
                      :key="d" 
                      small
                    >
                      <span class="caption">{{ d }} - {{ cnt }}</span>
                    </v-chip>
                  </v-card-text>
                </v-card>
              </v-flex>
            </v-layout>
          </v-card-text>
        </v-card>
      </v-expansion-panel-content>
    </v-expansion-panel>
  </v-layout>
</template>
<script>
export default {
  asyncData (app) {
    return app.$axios.get('/orders?$populate=customer')
      .then(result => {
        return result.data
      })
      .catch(error => {
        console.error('Erro ao ler os pedidos', error)
        return []
      })
      .then(orders => {
        return app.$axios.get('/locations')
          .then(result => {
            return {
              orders: orders,
              locations: result.data
            }
          })
      })
  },
  computed: {
    sources: function () {
      var o = new Set(this.orders.map(o => o.from))
      return [...o]
    }
  },
  methods: {
    getLocation(id) {
      var found = this.locations.filter(l => l._id === id)
      if(found.length == 0) {
        return null
      } else {
        return found[0]
      }
    },
    getPackagesCount(packages) {
      var summary = {}
      packages.forEach(p => {
        var dest = this.locations.filter(l => l._id === p.destination)[0]
        var count = summary[dest.name] || 0
        summary[dest.name] = ++count
      })
      return summary
    }
  }
}
</script>
